/*
  compile cmd: cc -o get_date_test_c get_date_c.c
  Don't forget to set your DATEMSK env var
*/

/*------------------ includes ----------------------------*/
#include <sys/time.h>

/*------------------ externals ---------------------------*/
extern int getdate_err;

/*------------------ prototypes --------------------------*/
void
print(struct tm* tm);

/*------------------ main --------------------------------*/
int
main(int argc, char** argv)
{
  int i = 1;
  struct tm*  time_tm     = NULL;  
  const char* aDateString = "01-Aug-2000 05:06:07";

  printf("\nDateString: %s\n\n", aDateString);

  for(;i < 4; i++)
  {
    printf("%d. conversion:\n", i);
    printf("-------------------------------------------------------------\n");
    time_tm = getdate(aDateString);
    if(getdate_err)
    {
      printf("Can't eval date string <%s>: %d\n", aDateString, getdate_err);
      getdate_err = 0;
    }
    else
    {
      print(time_tm);
      printf ("\ngetdate: %s\n", asctime(time_tm));
    }
  }

  return 0;
}

void
print(struct tm* tm)
{
  printf("Data of struct tm: \n"
         "tm_sec   : %d"
         "\ntm_min   : %d"
         "\ntm_hour  : %d"
         "\ntm_mday  : %d"
         "\ntm_mon   : %d"
         "\ntm_year  : %d"
         "\ntm_wday  : %d"
         "\ntm_yday  : %d"
         "\ntm_isdst : %d",
         tm->tm_sec, tm->tm_min, tm->tm_hour, tm->tm_mday, tm->tm_mon,
         tm->tm_year, tm->tm_wday, tm->tm_yday, tm->tm_isdst);
#ifdef	__USE_BSD
  printf("\ntm_gmtoff: %ld"
         "\ntm_zone  : %s",
         tm->tm_gmtoff, tm->tm_zone);
#endif
}
